package de.cliffbreak.varo.commands;

import java.io.IOException;

import com.destroystokyo.paper.Title;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryCloseEvent.Reason;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.json.simple.JSONObject;
import org.json.simple.JSONValue;
import org.json.simple.parser.ParseException;

import de.cliffbreak.varo.Varo;
import de.cliffbreak.varo.uitls.MessageUtils;
import de.cliffbreak.varo.uitls.WebUtils;

public class VaroCommand implements CommandExecutor {

    private Varo plugin;

    public VaroCommand(Varo plugin) {
        this.plugin = plugin;
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (!sender.hasPermission("varo.admin")) {
            sender.sendMessage("§c§lFehler: §r§cNicht genügend Rechte für dieses Kommando.");
            return true;
        }
        if (args.length == 2 && args[0].equals("unban")) {

            try {
                String result = WebUtils.GET("https://api.mojang.com/users/profiles/minecraft/" + args[1]);
                if (result.isEmpty()) {
                    sender.sendMessage("§c§lFehler: §r§cDer Spieler wurde nicht gefunden.");
                    return true;
                }
                JSONObject uuidObject = (JSONObject) JSONValue.parseWithException(result);
                if (!plugin.banUtils.isBanned(uuidObject.get("id").toString())) {
                    sender.sendMessage("§c§lFehler: §r§cDer Spieler ist nicht gebannt.");
                    return true;
                }
                plugin.banUtils.removeBan(uuidObject.get("id").toString());
                sender.sendMessage("§a§lErfolg: §r§aDer Spieler ist nun nicht mehr gebannt.");
            } catch (IOException | ParseException e) {
                sender.sendMessage(
                        "§c§lFehler:§r§c beim Verbinden mit der Mojang-API ist ein Fehler aufgetreten. Eventuell sind die Mojang Server down.");
                e.printStackTrace();
            }

        } else if (args.length == 1 && args[0].equals("start")) {
            sender.sendMessage("§aStarting...");
            for (Player p : Bukkit.getServer().getOnlinePlayers()) {
                // p.getInventory().clear(); //TODO: uncomment after debuging
                p.closeInventory(Reason.CANT_USE);
                for (PotionEffect potion : p.getActivePotionEffects())
                    p.removePotionEffect(potion.getType());

                p.addPotionEffect(new PotionEffect(PotionEffectType.BLINDNESS, 60 * 20, 1, false, false, false));
                p.sendTitle(new Title("TODO: Title, etc"));
            }
        } else if (args.length == 1 && args[0].equals("teamcolors")) {
            sender.sendMessage(MessageUtils.getRichTextComponent("§c" + "Team 01", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§6" + "Team 02", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§e" + "Team 03", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§2" + "Team 04", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§a" + "Team 05", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§b" + "Team 06", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§3" + "Team 07", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§9" + "Team 08", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§d" + "Team 09", ""));
            sender.sendMessage(MessageUtils.getRichTextComponent("§5" + "Team 10", ""));

        } else if (args.length == 2 && args[0].equals("portal")) {
            if (args[1].equals("enable")) {
                this.plugin.canCreatePortal = true;
                sender.sendMessage("§c§lWarnung: §r§cPortale können nun von JEDEM Spieler erstellt werden.");
            } else if (args[1].equals("disable")) {
                this.plugin.canCreatePortal = false;
                sender.sendMessage("§a§lErfolg: §r§aEs können nun keine Portale mehr erstellt werden..");
            } else {
                sender.sendMessage("§c§lFehler: §r§cBitte überprüfe deine Eingabe.");
            }
        } else if (args.length == 1 && args[0].equals("test")) {
            if (sender instanceof Player) {
                plugin.npcManager.createClone((Player) sender, false);
            } else {
                sender.sendMessage("§c§lFehler:§r§c Dieses Kommando kann nur durch einen Spieler ausgeführt werden.");
            }
        } else if (args.length == 1 && args[0].equals("testremove")) {
            if (sender instanceof Player) {
                plugin.npcManager.removeClone(((Player) sender));
            } else {
                sender.sendMessage("§c§lFehler:§r§c Dieses Kommando kann nur durch einen Spieler ausgeführt werden.");
            }
        } else {
            sender.sendMessage("\n§6========== §b§lCliffbreak.de VARO §r§6============\n ");
            sender.sendMessage("§a/varo start: §rStarte das Varo Projekt!");
            sender.sendMessage("§a/varo unban [Spieler]: §rSpieler wieder auf den Server lassen");
            sender.sendMessage("§a/varo portal [enable/disable]: §rAktiviere/Deaktiviere die Portal-Erstellung");
            sender.sendMessage("§a/varo teamcolors: §rZeige verfügbare Team-Farben an");
            sender.sendMessage("§a/varo test: §rErstelle einen Klon");
            sender.sendMessage("§a/varo testremove: §rLösche den Klon");
            sender.sendMessage("\n§6==========================================");
        }
        return true;
    }

}