package de.cliffbreak.varo.uitls;

import java.util.ArrayList;
import java.util.UUID;

import de.cliffbreak.varo.Varo;

public class BanUtils {

    private final Varo plugin;

    public BanUtils(Varo plugin) {
        this.plugin = plugin;
    }

    public boolean isBanned(UUID uuid) {
        return isBanned(uuid.toString().replace("-", ""));
    }

    public boolean isBanned(String compressedUuid) {
        @SuppressWarnings("unchecked")
        final ArrayList<String> bans = (ArrayList<String>) this.plugin.config.get("Varo.Bans");
        return bans.contains(compressedUuid);
    }

    public void addBann(UUID uuid) {
        @SuppressWarnings("unchecked")
        final ArrayList<String> bans = (ArrayList<String>) this.plugin.config.get("Varo.Bans");
        bans.add(uuid.toString().replace("-", ""));
        this.plugin.config.set("Varo.Bans", bans);
        this.plugin.saveConfiguration();
    }

    public void removeBan(String compressedUuid) {
        @SuppressWarnings("unchecked")
        final ArrayList<String> bans = (ArrayList<String>) this.plugin.config.get("Varo.Bans");
        bans.remove(compressedUuid);
        this.plugin.config.set("Varo.Bans", bans);
        this.plugin.saveConfiguration();
    }

}